#include <pic.h>


#define	XTAL_FREQ	4MHZ	

#define	MHZ	*1000L		
#define	KHZ	*1	

#define	DelayUs(x)	{ unsigned char _dcnt;  _dcnt = (x)/((12MHZ)/(XTAL_FREQ))|1; while(--_dcnt != 0) continue; }



 __CONFIG (INTIO & UNPROTECT & LVPDIS  & BORDIS & MCLRDIS & PWRTEN & WDTDIS);


__EEPROM_DATA(0x01,0xFF,0x23,0x28,0x23,0x8c,0x23,0xB4);
__EEPROM_DATA(0x24,0x0E,0x24,0x72,0x24,0xEA,0x26,0x0C);
__EEPROM_DATA(0x26,0x66,0x26,0xAC,0x26,0xD4,0x27,0x1A);
__EEPROM_DATA(0x27,0x6A,0x27,0xCE,0x28,0x00,0x28,0x28);
__EEPROM_DATA(0x28,0x5A,0x28,0xA0,0x28,0xD2,0x28,0xFA);
__EEPROM_DATA(0x29,0x36,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF);


#define	RS_PIN   RB5 
#define	EN_PIN   RB4
#define D4_PIN   RB0
#define D5_PIN   RB1
#define D6_PIN   RB2
#define D7_PIN   RB3

#define DA RA0
#define CL RA1
#define CE RA2

#define step 5 // frequency step (50k)

#define renc_A RB6 
#define renc_B RB7 
#define min_freq 8750 // 6500 // min frequency
#define max_freq 10800 // max frequency
 
unsigned int freq, tmp, x;   
unsigned char  chan, mode, enc;   
unsigned char  y, i, z, x5, x4, x3, x2, x1; 
unsigned char byte;
unsigned char oldstate, oldstate2;

const char prm[]={21,14,4,31,17,17,31,0};

const char barr1[]={16,16,16,31,16,16,16,0};
const char barr2[]={8,8,8,31,8,8,8,0};
const char barr3[]={4,4,4,31,4,4,4,0};
const char barr4[]={2,2,2,31,2,2,2,0};
const char barr5[]={1,1,1,31,1,1,1,0};

void DelayMs(unsigned char cnt){
	unsigned char	i;
	do {
		i = 4;
		do {
			DelayUs(250);
		} while(--i);
	} while(--cnt);
}

void Lcd_Dat(char d){
if((d)&1) D4_PIN =1; else D4_PIN =0;
if((d)&2) D5_PIN =1; else D5_PIN =0;
if((d)&4) D6_PIN =1; else D6_PIN =0;
if((d)&8) D7_PIN =1; else D7_PIN =0;
}

void Lcd_Strobe(void){
EN_PIN=1;
DelayUs(2);
EN_PIN=0;
}

void Lcd_Cmd(unsigned char c){
DelayUs(50);
Lcd_Dat ((c&0xF0)>>4);             
DelayUs(2);	
Lcd_Strobe();
DelayUs(10);
Lcd_Dat(c&0x0F);
DelayUs(2);	
Lcd_Strobe();
DelayUs(10);
}

void lcd_clear(void){
Lcd_Cmd(0x01);
DelayMs(2);
}

void lcd_blink(void){
Lcd_Cmd(0x08);
DelayMs(250);
Lcd_Cmd(0x0C);
DelayMs(2);
}

void lcd_putch(char c){
RS_PIN = 1;
Lcd_Cmd(c);
RS_PIN = 0;
}

void  lcd_gotoxy (char row, char col){
 if(row == 0)
 {
  Lcd_Cmd(0x80 + col);
 }
 else if(row == 1)
 {
  Lcd_Cmd(0xC0 + col);
 }
}

void lcd_init(void){

RS_PIN = 0;
EN_PIN = 0;
Lcd_Dat(0x00);
DelayMs(15);
Lcd_Dat(0b00000011);
Lcd_Strobe();
DelayMs(10);
Lcd_Strobe();
DelayUs(200);
Lcd_Strobe();
DelayUs(200);
Lcd_Dat(0b00000010);
Lcd_Strobe();
DelayUs(200);
Lcd_Cmd (0b00101000);    
Lcd_Cmd (0b00001100);    
Lcd_Cmd (0b00000110);    
}
//----end----

//Bargraf
void barnastr (char z){

Lcd_Cmd (64);
for (i = 0; i<=7; i++) lcd_putch(barr1[i]);
Lcd_Cmd (96);
for (i = 0; i<=7; i++) lcd_putch(barr2[i]);
Lcd_Cmd (88);
for (i = 0; i<=7; i++) lcd_putch(barr3[i]);
Lcd_Cmd (80);
for (i = 0; i<=7; i++) lcd_putch(barr4[i]);
Lcd_Cmd (72);
for (i = 0; i<=7; i++) lcd_putch(barr5[i]);

y=80;
i=5;
lcd_gotoxy(1,(z/i));
lcd_putch ((y-z)%5);
}
//----end----
//User simbol
void Antenna (void){

Lcd_Cmd (120);
for (i = 0; i<=7; i++) lcd_putch(prm[i]);

lcd_gotoxy(0,0);
lcd_putch(7);
}
//----end----

void decomp (unsigned int x){
x5 = (x/10000) %10 + 48; 
x4 = (x/1000) %10 + 48;
x3 = (x/100) %10 + 48;
x2 = (x/10) %10 + 48;
x1 = (x%10) + 48;
}

void mode_display (void){
unsigned int tmp;
lcd_gotoxy (0,0);
Antenna ();
decomp (chan);  

lcd_putch (x2);
lcd_putch (x1);

lcd_putch (' '); 
  if (mode == 2) {
    mode = 0;
  }
  if (mode == 0) {
lcd_putch ('C');
lcd_putch ('H');
  }
  if (mode == 1) {
lcd_putch ('F');
lcd_putch ('M');
}
lcd_putch (' '); 

decomp (freq);  
if (x5==0x30)x5=' ';
lcd_putch (x5);
lcd_putch (x4);
lcd_putch (x3);
lcd_putch ('.');
lcd_putch (x2);
lcd_putch (x1);
lcd_putch ('M'); //  M
lcd_putch ('H'); //  H
lcd_putch ('z'); //  z

lcd_gotoxy(1,0);

for(i=0;i<16;i++)lcd_putch ('-');
tmp = (freq - 8740)/26;  //   87.5-108.00
// tmp = (freq - 6480)/54;  //   65.00-108.00

barnastr(tmp); 
}
//---  LM7001---
//   
void lm7001SendByte(unsigned char byte) {
  for (i = 0; i < 8; i++) {
    if (byte&0x1) DA = 1;
    else
    DA = 0;
    DelayUs(3);
    CL = 1;
    DelayUs(3);
    CL = 0;
    byte = byte >> 1;
    DelayUs(3);
    DA = 0;
  }
}
//  
void send_lm7001(void){
  unsigned int divisor;
  divisor = (freq + 1070)/5; //= 100.000k/50k

  CL = 0; 
  CE = 1; 
  DelayUs(3);

  lm7001SendByte(divisor & 0x00FF);
  lm7001SendByte((divisor & 0xFF00)>>8);
  lm7001SendByte(0b11000000);
  //            (0b11000000) - 50k
  //            (0b10000000) - 100k
  DelayUs(3);
  CE = 0; 
}


/**
//---  LC72131---
//   
void LC72131SendByte(unsigned char byte) {
  for (i = 0; i < 8; i++) {
   if (byte&0x01) DA = 1;
   else DA = 0;
    DelayUs(3);
    CL = 1;
    byte = byte >> 1;
    DelayUs(3);
    CL = 0;
  }
}

//  
void send_LC72131(void) {
  unsigned int divisor;
  divisor = (freq + 1070) / 5 ; //= (100.000 + 10.700)/50k
  //           + 

  //IN2
  CE=0;
  LC72131SendByte (0b00101001);   //adress
  CE=1;
  LC72131SendByte (0b10101010);
  LC72131SendByte (0b11110010);
  LC72131SendByte (0b00000000);
  CE=0;
  
  //IN1
  CE=0;
  LC72131SendByte (0b00101000);     //adress
  CE=1;
  LC72131SendByte (divisor & 0x00FF);
  LC72131SendByte ((divisor & 0xFF00)>>8);
  LC72131SendByte (0b00111010); // step 50,  xtal 7.200, FM
  //              (0b0011 0 010)   step 50,  xtal 4.500, FM

  CE=0;
}
//---end---
**/

// ===   
void write_all (void){
EEPROM_WRITE (0, chan);
EEPROM_WRITE (chan * 2,(freq&0xFF00)>>8);
EEPROM_WRITE (1 + chan * 2,(freq&0x00FF));
}

// ===     
void read_freq (void){
if (chan>30) chan=30; //   
if (chan<1) chan=1;  //   
if (freq > max_freq) freq = min_freq;
if (freq < min_freq) freq = max_freq;

//send_LC72131();
send_lm7001();
mode_display ();
}

// ===   
void read_all (void){
  freq = EEPROM_READ(chan * 2);
  freq = freq<<8 | EEPROM_READ(1 + chan * 2);
}


void Encoder (void){
if ( renc_A != ((enc&0x40)>>6) || renc_B != ((enc&0x80)>>7) ){
 enc=enc>>2 | (PORTB & 0b11000000);
      if (enc == 0b11010010 ){ 
        if (mode == 0) {
          if (chan < 30)  chan++;
            read_all ();
          }
          if (mode == 1){
            freq += step;
          }
            read_freq ();
     }else if (enc == 0b11100001 ){ 
        if (mode == 0) {
          if (chan > 1)  chan--;
            read_all ();
          }
          if (mode == 1){
            freq -=  step;
          }
            read_freq ();
    }
  }
}

void mode_key (void){

   if (RA3 == 0){
    oldstate = 1;
    DelayMs(10);
   }

   if (oldstate && RA3 == 1){ //write mem
    oldstate = 0;
    read_freq();
    write_all();
    lcd_blink();
   }

   if (RA4 == 0){
    oldstate2 = 1;
    DelayMs(10);
   }

   if (oldstate2 && RA4 == 1){ //mode
    oldstate2 = 0;
    mode++;
    mode_display();
   }
}

void main(void) {

  RBPU = 0;
  TRISA = 0b00011000;
  TRISB = 0b11000000;
  PORTA = 0;
  INTCON = 0;
  CMCON = 0xff;

  lcd_init ();
  lcd_clear ();
  chan = EEPROM_READ(0);
  read_all (); 
  mode_display ();
  read_freq ();
  enc = 0b11000000;
  while(1){
  Encoder ();
  mode_key ();
 }
}
