#include <pic.h>
#define	XTAL_FREQ	4MHZ		

#define	MHZ	*1000L			
#define	KHZ	*1

#define	DelayUs(x)	{ unsigned char _dcnt;  _dcnt = (x)/((12MHZ)/(XTAL_FREQ))|1; while(--_dcnt != 0) continue; }

__CONFIG (INTIO & UNPROTECT & LVPDIS  & BORDIS & MCLRDIS & PWRTEN & WDTDIS);

#define	RS_PIN      RB5                 // RS
#define	EN_PIN      RB4                 // EN
#define D4_PIN      RB0                 // D4
#define D5_PIN      RB1                 // D5
#define D6_PIN      RB2                 // D6
#define D7_PIN      RB3                 // D7

#define DA RA0
#define CL RA1
#define CE RA2

#define renc_A RB6 
#define renc_B RB7 

#define	step 25          // 25 kHz 
#define	step_fast 1000   // 1 MHz
#define	freq_min 118000
#define	freq_max 138000

#define	freqi 10700      //  
 
unsigned long freq, d, r; 
unsigned char chan, mode, byte; 
unsigned char enc;
unsigned char  i, j; 
unsigned char oldstate, oldstate2;
 
void DelayMs(unsigned char cnt){
	unsigned char	i;
	do {
		i = 4;
		do {
			DelayUs(250);
		} while(--i);
	} while(--cnt);
}

//----      ----
void Lcd_Strobe(void){
EN_PIN=1;
DelayUs(2);
EN_PIN=0;
}

void Lcd_Dat(char d){
if((d)&1) D4_PIN =1; else D4_PIN =0;
if((d)&2) D5_PIN =1; else D5_PIN =0;
if((d)&4) D6_PIN =1; else D6_PIN =0;
if((d)&8) D7_PIN =1; else D7_PIN =0;
}

void Lcd_Cmd(char c){
DelayUs(50);
Lcd_Dat ((c&0xF0)>>4);
DelayUs(2);	
Lcd_Strobe();
DelayUs(10);
Lcd_Dat(c&0x0F);
DelayUs(2);	
Lcd_Strobe();
DelayUs(10);
}

void Lcd_Clear(void){
Lcd_Cmd(0x01);
DelayMs(2);
}

void lcd_blink(void){
Lcd_Cmd(0x08);
DelayMs(250);
Lcd_Cmd(0x0C);
DelayMs(2);
}

void  Lcd_Chr(char row, char col, char c){
 if(row == 1)
 {
  Lcd_Cmd(0x80 + col-1);
 }
 else if(row == 2)
 {
  Lcd_Cmd(0xC0 + col-1);
 }
RS_PIN = 1;
Lcd_Cmd(c);
RS_PIN = 0;
}

void  Lcd_Out(char row, char col, const char *s){
 if(row == 1)
 {
  Lcd_Cmd(0x80 + col-1 );
 }
 else if(row == 2)
 {
  Lcd_Cmd(0xC0 + col-1);
 }
RS_PIN = 1;
while(*s) Lcd_Cmd (*s++);
RS_PIN = 0;
}

void Lcd_Init(void){
RS_PIN = 0;
EN_PIN = 0;
Lcd_Dat(0x00);
DelayMs(15);
Lcd_Dat(0b00000011);
Lcd_Strobe();
DelayMs(10);
Lcd_Strobe();
DelayUs(200);
Lcd_Strobe();
DelayUs(200);
Lcd_Dat(0b00000010);
Lcd_Strobe();
DelayUs(200);
Lcd_Cmd (0b00101000);    
Lcd_Cmd (0b00001100);    
Lcd_Cmd (0b00000110);    
}
//------

void lcd_mode(void) {
  if (mode == 3) {
    mode = 0;
  }
  if (mode == 0) {
    Lcd_Out(2, 1, "MEM");
  }
  if (mode == 1) {
    Lcd_Out(2, 1, "FST");
  }
  if (mode == 2) {
    Lcd_Out(2, 1, "TUN");
  }
}

void mode_display(void) {
 d = 100000, r = freq;
 i = 1;
  while (i <= 7) {
    j = r / d + 48;
    if (i < 2 &&  j == 48){
         Lcd_Chr(1, i, ' ');
         }
    else {
         Lcd_Chr(1, i, j);
    }
    if (i == 3) {
       Lcd_Chr(1, ++i, '.');
    }
    r = r % d;
    d /= 10;
    i++;
  }
  j = chan / 10;
  Lcd_Out(2, 5, "CH");
  Lcd_Chr(2, 7, j + 48);                
  Lcd_Chr(2, 8, (chan - (j*10) + 48)); 
}

//---  LM7001---
//   
void lm7001SendByte(unsigned char byte) {
  for (i = 0; i < 8; i++) {
    if (byte&0x1) DA = 1;
    else
    DA = 0;
    DelayUs(3);
    CL = 1;
    DelayUs(3);
    CL = 0;
    byte = byte >> 1;
    DelayUs(3);
    DA = 0;
  }
}

//  
void send_lm7001(void){
  unsigned int divisor;
  divisor = (freq + freqi)/25; //      
  //          + 

  CL = 0; // CL
  CE = 1; // CE
  DelayUs(3);

  lm7001SendByte(divisor & 0x00FF);
  lm7001SendByte((divisor & 0xFF00)>>8);
  lm7001SendByte(0b10100000);  //   
  //            (0b11000000) - 50k
  //            (0b10000000) - 100k
  //            (0b10100000) - 25k
  DelayUs(3);
  CE = 0; // CE
}
//------

/***
//---  LC72131---
//   
void LC72131SendByte(unsigned char byte) {

  for (i = 0; i < 8; i++) {
   if (byte&0x01) DA = 1;
   else DA = 0;
    DelayUs(3);
    CL = 1;
    byte = byte >> 1;
    DelayUs(3);
    CL = 0;
  }
}
//  
void send_LC72131(void) {
  unsigned int divisor;
  divisor = (freq + freqi) / 25 ; //       
  //          +                             
                                                     
  //IN2                                              
  CE=0;                                              
  LC72131SendByte (0b00101001);   //adress           
  CE=1;                                              
  LC72131SendByte (0b10101010);                      
  LC72131SendByte (0b11110010);                      
  LC72131SendByte (0b00000000);                     
  CE=0;

  //IN1
  CE=0;
  LC72131SendByte (0b00101000);     //adress
  CE=1;
  LC72131SendByte (divisor & 0x00FF);
  LC72131SendByte ((divisor & 0xFF00)>>8);
  LC72131SendByte (0b01000010); ////   , , 

  //       (0b0001 0 010);    step 100, xtal 4.500, FM
  //       (0b0001 1 010)     step 100, xtal 7.200, FM
  //       (0b0011 0 010)     step 50,  xtal 4.500, FM
  //       (0b0100 0 010)     step 25,  xtal 4.500, FM
  //       (0b1010 0 010)     step 10,  xtal 4.500, FM

  CE=0;
}
//------
***/

void read_freq (void){
if (chan>30) chan=30; 
if (chan<1) chan=1;  

if (freq > freq_max) freq = freq_min; 
if (freq < freq_min) freq = freq_max; 

mode_display ();

//send_LC72131();       //      LC72131
send_lm7001();

}

//     
void read_all (void){
  freq = EEPROM_READ(chan * 4);
  freq = freq<<8 | EEPROM_READ(1 + chan * 4);
  freq = freq<<8 | EEPROM_READ(2 + chan * 4);
  freq = freq<<8 | EEPROM_READ(3 + chan * 4);
}

//     
void write_all (void){
EEPROM_WRITE (0, chan);
EEPROM_WRITE     (chan * 4,(freq&0xff000000) >> 24);
EEPROM_WRITE (1 + chan * 4,(freq&0x00ff0000) >> 16);
EEPROM_WRITE (2 + chan * 4,(freq&0x0000ff00) >> 8);
EEPROM_WRITE (3 + chan * 4,(freq&0x000000FF));
}

//---- ----
void Encoder (void){
//               7               8  
if ( renc_A != ((enc&0x40)>>6) || renc_B != ((enc&0x80)>>7) ){
 enc=enc>>2 | (PORTB & 0b11000000);
      if (enc == 0b11010010 ){ 
        if (mode == 0) {
          if (chan < 30)  chan++;
            read_all ();
          }
          if (mode == 1){
            freq +=  step_fast;
          }
          if (mode == 2){
            freq +=  step;
          }
            read_freq ();
     }else if (enc == 0b11100001 ){ 
        if (mode == 0) {
          if (chan > 1)  chan--;
            read_all ();
          }
          if (mode == 1){
            freq -=  step_fast;
          }
          if (mode == 2){
            freq -=  step;
          }
            read_freq ();
    }
  }
}
//------


//------
void Key (void){

   if (RA3 == 0){
    oldstate = 1;
    DelayMs(10);
   }

   if (oldstate && RA3 == 1){
    oldstate = 0;
    read_freq();  //  
    write_all();  //   
    lcd_blink();  //  
   }

   if (RA4 == 0){
    oldstate2 = 1;
    DelayMs(10);
   }

   if (oldstate2 && RA4 == 1){
    oldstate2 = 0;
    mode++;	//  
	lcd_mode();
   }
}
//------

void main(void) {

  RBPU = 0;
  TRISA = 0b00011000;
  TRISB = 0b11000000;
  PORTA = 0;
  INTCON = 0;
  CMCON = 0xff;

  Lcd_Init ();
  Lcd_Clear ();

  chan = EEPROM_READ(0);
  read_all (); 
  read_freq ();
  enc = 0b11000000; //  0b00000011
  lcd_mode ();

  while(1){
Encoder();
Key ();
 }
}

